Gamestate = require "gamestate"
local citymap = Gamestate.new()

function love.load()
	generated = false
	activeloc = 1

	Gamestate.registerEvents()
	Gamestate.switch(citymap)
	
end

function citymap:enter()
	
	overlapping = true
	foundoverlap = false
	
	
	if generated == false then
		mapgen()
		
		while overlapping == true do
			
		checkit = mapgen()
			if checkit == true then overlapping = true end
			if checkit == false then overlapping = false end
		end
		
		generated = true
		currentstation = math.random(2, 20)
	end
	
	currentcity = love.graphics.newImage("city_glasgow.png")
	loc_inactive = love.graphics.newImage("loc_inactive.png")
	loc_active = love.graphics.newImage("loc_active.png")
	loc_visited = love.graphics.newImage("loc_visited.png")
	loc_station = love.graphics.newImage("loc_station.png")
	
end

function mapgen()

	pointer = { }
	
	for i = 1, 20 do pointer[i] = {x = 0, y = 0, links = 0, linkedto = {} } end

	pointers = {
		pox = {64, 89, 114, 139, 164, 189, 214, 239, 264, 289, 314, 339, 364, 389, 414, 439, 464, 489, 514},
		poy = {58, 78, 98, 118, 138, 158, 178, 198, 218, 238, 258, 278, 298, 318, 338, 358, 378, 398},
	}
	
	local x_coordinates = {  }
	local y_coordinates = {  }

	local x_lookup = { [114] = { [98] = true}, [239] = { [198] = true }, [364] = { [298] = true } }
	math.randomseed(os.time())

	local coordinate_count = 0
	local coordinate_index = 1

	while (coordinate_count < 20) do

		new_x_coordinate = math.random(1, 19)
			pointer[coordinate_index].x = pointers.pox[new_x_coordinate]
		new_y_coordinate = math.random(1, 18)
			pointer[coordinate_index].y = pointers.poy[new_y_coordinate]
		
		-- check if a y coordinate table is present for this x value, if not create it
		local y_lookup = x_lookup[new_x_coordinate]
		if y_lookup == nil then
			y_lookup = {}
			x_lookup[new_x_coordinate] = y_lookup
		end
		
		if not y_lookup[new_y_coordinate] then
			y_lookup[new_y_coordinate] = true
			x_coordinates[coordinate_index] = new_x_coordinate
			y_coordinates[coordinate_index] = new_y_coordinate
			coordinate_count = coordinate_count + 1
			coordinate_index = coordinate_index + 1
		else
			return true
		end
	end

		for i = 1, 20 do
			local howmanylinks = math.random(1, 3)
			while pointer[i].links < howmanylinks do
				local randompoint = math.random(1, 20)
				islinked = checklink(i, randompoint)
					if islinked == true then
					table.insert(pointer[i].linkedto, randompoint)
					pointer[i].links = pointer[i].links + 1
					end 
			end
		end
		
		
	return false
	
end

function citymap:update()
	
end

function citymap:draw()
	love.graphics.draw(currentcity, 0, 0)
	
	love.graphics.setLineWidth(2)
	 
	 
    for i, v in ipairs(pointer) do
            for j, w in ipairs(pointer) do
                    for y = 1, #v.linkedto do
                            for r = 1, #w.linkedto do
                                    if v.linkedto[y] == j or w.linkedto[r] == i then
                                            love.graphics.line(v.x+7, v.y+7, w.x+7, w.y+7)
                                    end
                            end
                    end
            end
    end
	
	for j = 1, 20 do
		love.graphics.draw(loc_inactive, pointer[j].x, pointer[j].y)
			if pointer[j].visted == true then
				love.graphics.draw(loc_visited, pointer[j].x, pointer[j].y)
			end
	end
	
	love.graphics.draw(loc_active, pointer[activeloc].x, pointer[activeloc].y)
	
	love.graphics.draw(loc_station, pointer[currentstation].x-1, pointer[currentstation].y-12)
	
	mousex, mousey = love.mouse.getPosition()
		
		for h = 1, #pointer do
			if mousex > pointer[h].x and mousex < (pointer[h].x + 20) and mousey > pointer[h].y and mousey < (pointer[h].y + 20) then
				
				--love.graphics.setNewFont(30)
				--love.graphics.print(pointer[h].links, pointer[h].x, pointer[h].y)
				
				if love.mouse.isDown("l") then
					for r = 1, #pointer[activeloc].linkedto do
						if pointer[activeloc].linkedto[r] == h or pointer[h].linkedto[r] == activeloc then
					
						pointer[activeloc].visted = true
						activeloc = h
							if pointer[activeloc].visted ~= true then
							--Gamestate.switch(game)
							end
						end
					end
				end
			end
		end
	
end

function checklink(from, toward)

	if from == toward then
	return false
	end

	if pointer[from].x >= pointer[toward].x and pointer[from].x < (pointer[toward].x + 170) or pointer[from].x <= pointer[toward].x and pointer[from].x > (pointer[toward].x - 170) then
		if pointer[from].y >= pointer[toward].y and pointer[from].y < (pointer[toward].y + 170) or pointer[from].y <= pointer[toward].y and pointer[from].y > (pointer[toward].y - 170) then				
		return true
		end
	end
	
	return false
end

function citymap:keyreleased(key, unicode)
   
   if key == 'r' then
		generated = false
        Gamestate.switch(citymap)
    end
	
end